unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ComCtrls,
  StdCtrls, Buttons;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Edit1: TEdit;
    Label3: TLabel;
    SaveDialog1: TSaveDialog;
    unattend: TEdit;
    winnt_ort: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Form1Create(Sender: TObject);
  private
   procedure inischreiben(Section,key,default:string);
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation
 uses unit2,unit3,inifiles;

{ TForm1 }

procedure TForm1.inischreiben(Section,key,default:string);
var ini_path:string;
    ini:TInifile;
begin
 ini_path:=form1.unattend.text;
 Ini := TIniFile.Create(ini_path);
 ini.WriteString(section,key,default);
 ini.free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
opendialog1.filename:='unattend.txt';
opendialog1.filter:='Textdatei|*.txt';
 if opendialog1.execute then
  begin
  unattend.text:=opendialog1.filename;
  form3.Form3Create(sender);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 opendialog1.filename:='winnt32.exe';
opendialog1.filter:='Winnt32.exe|*.exe';
 if opendialog1.execute then winnt_ort.text:=opendialog1.filename;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  form3.showmodal;
end;

procedure TForm1.Button4Click(Sender: TObject);
var s:longint;
begin
 s:=executeprocess('notepad.exe',unattend.text);
 if s <> 0 then
 showmessage('Folgender Fehler ist aufgetreten: '+IntToStr(s));
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if (unattend.text ='') or (winnt_ort.text='') then
  begin
    showmessage('Unattend.txt and/or winnt32.exe not insert');
    exit;
  end;
  form2.unattend.caption:=unattend.text;
  form2.winnt.caption:=winnt_ort.text;
  form2.edit3.text:=winnt_ort.text;
  form2.showmodal;
end;

procedure TForm1.Button6Click(Sender: TObject);
var f:textfile;
begin
  assignfile(f,unattend.text);
  try
  rewrite(f);
   writeln(f,';SetupMgrTag');
   writeln(f,';Created with the opensource PE-Creator (c) by Dirk Paehl');
   //Darf nicht geaendert werden. Do not change this
  finally
  closefile(f);
  end;
   if Form3.CheckGroup1.checked[0] then inischreiben('DATA','AutoPartition','1') else inischreiben('DATA','AutoPartition','0');
   if Form3.CheckGroup1.checked[1] then inischreiben('DATA','MsDosInitiated','"1"') else inischreiben('DATA','MsDosInitiated','"0"');
   if Form3.CheckGroup1.checked[2] then inischreiben('DATA','UnattendedInstall','"Yes"') else inischreiben('DATA','UnattendedInstall','"no"');
   if Form3.produktkey.text <>'' then
    begin
     inischreiben('USERDATA','ProductKey','ProductKey');
     inischreiben('USERDATA','ProductID',Form3.produktkey.text);
    end;
   if Form3.orgname.text <>'' then inischreiben('USERDATA','OrgName','"'+Form3.orgname.text+'"');
   if Form3.full_name.text <>'' then inischreiben('USERDATA','FullName','"'+Form3.full_name.text+'"');
   if Form3.computername.text <>'' then inischreiben('USERDATA','ComputerName',Form3.ComputerName.text);
   if Form3.OemPreinstall.checked then inischreiben('Unattended','OemPreinstall','yes') else inischreiben('Unattended','OemPreinstall','no');
   if Form3.Oemskipeula.checked then inischreiben('Unattended','OemSkipEula','yes') else inischreiben('Unattended','OemSkipEula','no');
   if Form3.autoactive.checked then inischreiben('Unattended','AutoActivate','yes') else inischreiben('Unattended','AutoActivate','no');
   if Form3.unattendswitch.checked then inischreiben('Unattended','UnattendSwitch','yes') else inischreiben('Unattended','UnattendSwitch','no');
   if Form3.waitforReboot.checked then inischreiben('Unattended','WaitForReboot','yes') else inischreiben('Unattended','WaitForReboot','no');
   if Form3.unattendmode.text <>'' then
   inischreiben('Unattended','UnattendMode',Form3.unattendmode.text);
   if Form3.driversigningpolicy.text <>'' then
   inischreiben('Unattended','DriverSigningPolicy',Form3.driversigningpolicy.text);
   if Form3.targetpath.text <>'' then
   inischreiben('Unattended','TargetPath',Form3.targetpath.text);
   if Form3.repartition.checked then inischreiben('Unattended','Repartition','yes') else inischreiben('Unattended','Repartition','no');
   if Form3.OemPnPDriversPath.text <>'' then
   inischreiben('Unattended','OemPnPDriversPath',Form3.OemPnPDriversPath.text);
   if Form3.ProgramFilesDir.text <>'' then
   inischreiben('Unattended','ProgramFilesDir',Form3.ProgramFilesDir.text);
   if Form3.CommonProgramFileDir.text <>'' then
   inischreiben('Unattended','CommonProgramFileDir',Form3.CommonProgramFileDir.text);
   //if Form3.keyboardlayout.text <>'' then
   //inischreiben('Unattended','KeyboardLayout',+'"'+Form3.keyboardlayout.text+'"');
   if Form3.adminpassword.text <>'' then
   begin
    inischreiben('GuiUnattended','AdminPassword','"'+Form3.adminpassword.text+'"');
    inischreiben('GuiUnattended','EncryptedAdminPassword','no');
   end;
   if Form3.oemskipregional.checked then inischreiben('GuiUnattended','OemSkipWelcome','1') else inischreiben('GuiUnattended','OemSkipWelcome','0');
   if Form3.oemskipwelcome.checked then inischreiben('GuiUnattended','OEMSkipRegional','1') else inischreiben('GuiUnattended','OEMSkipRegional','0');
   inischreiben('GuiUnattended','TimeZone',form3.timezone.text[1]+form3.timezone.text[2]+form3.timezone.text[3]);
   if Form3.Workgroup.text <>'' then
    inischreiben('Identification','JoinWorkgroup',Form3.Workgroup.text);
    inischreiben('Networking','InstallDefaultComponent','Yes');
   if Form3.msn_messenger.checked then inischreiben('Components','msmsgs','on') else inischreiben('Components','msmsgs','off');
   if Form3.msn_explorer.checked then inischreiben('Components','msmexplr','on') else inischreiben('Components','msmexplr','off');
   if Form3.freecell.checked then inischreiben('Components','freecell','on') else inischreiben('Components','freecell','off');
   if Form3.hearts.checked then inischreiben('Components','hearts','on') else inischreiben('Components','hearts','off');
   if Form3.minesweeper.checked then inischreiben('Components','minesweeper','on') else inischreiben('Components','minesweeper','off');
   if Form3.pinball.checked then inischreiben('Components','pinball','on') else inischreiben('Components','pinball','off');
   if Form3.solitaire.checked then inischreiben('Components','solitaire','on') else inischreiben('Components','solitaire','off');
   if Form3.spider.checked then inischreiben('Components','spider','on') else inischreiben('Components','spider','off');
   if Form3.spider.checked then inischreiben('Components','zonegames','on') else inischreiben('Components','zonegames','off');
   if Form3.acessibity_wizard.checked then inischreiben('Components','accessopt','on') else inischreiben('Components','accessopt','off');
   if Form3.calc.checked then inischreiben('Components','calc','on') else inischreiben('Components','calc','off');
   if Form3.character_map.checked then inischreiben('Components','charmap','on') else inischreiben('Components','charmap','off');
   if Form3.chat.checked then inischreiben('Components','chat','on') else inischreiben('Components','chat','off');
   if Form3.phone_dialer.checked then inischreiben('Components','dialer','on') else inischreiben('Components','dialer','off');
   if Form3.hyperterminal.checked then inischreiben('Components','hypertrm','on') else inischreiben('Components','hypertrm','off');
   if Form3.sample_sounds_clips.checked then inischreiben('Components','media_clips','on') else inischreiben('Components','media_clips','off');
   if Form3.mouse_pointers.checked then inischreiben('Components','mousepoint','on') else inischreiben('Components','mousepoint','off');
   if Form3.mediaplayer.checked then inischreiben('Components','mplay','on') else inischreiben('Components','mplay','off');
   if Form3.ms_wordpad.checked then inischreiben('Components','mswordpad','on') else inischreiben('Components','mswordpad','off');
   if Form3.paints.checked then inischreiben('Components','paint','on') else inischreiben('Components','paint','off');
   if Form3.sound_recorder.checked then inischreiben('Components','rec','on') else inischreiben('Components','rec','off');
   inischreiben('Display','BitsPerPixel',Form3.bitsperpixel.text);
   inischreiben('Display','Xresolution',Form3.xresolution.text);
   inischreiben('Display','Yresolution',Form3.yresolution.text);
   inischreiben('Display','Vrefresh',Form3.vrefresh.text);
   if Form3.standardmenu.checked then inischreiben('Shell','DefaultStartPanelOff','yes') else inischreiben('Shell','DefaultStartPanelOff','no');
   if Form3.classicmenu.checked then inischreiben('Shell','DefaultThemesOff','yes') else inischreiben('Shell','DefaultThemesOff','no');
   if Form3.classic_theme.text <>'' then inischreiben('Shell','CustomDefaultThemeFile',Form3.classic_theme.text);
   if Form3.Proxy_enable.checked then inischreiben('Proxy','Proxy_Enable','1') else inischreiben('Proxy','Proxy_Enable','0');
   if Form3.Use_Same_Proxy.checked then inischreiben('Proxy','Use_Same_Proxy','1') else inischreiben('Proxy','Use_Same_Proxy','0');
   inischreiben('Proxy','FTP_Proxy_Server',Form3.ftp.text);
   inischreiben('Proxy','Gopher_Proxy_Server',Form3.gopher.text);
   inischreiben('Proxy','HTTP_Proxy_Server',Form3.http.text);
   inischreiben('Proxy','SECURE_Proxy_Server',Form3.https.text);
   inischreiben('Proxy','SOCKS_Proxy_Server',Form3.socks.text);

   inischreiben('RegionalSettings','LanguageGroup',Form3.languagegroup.text);
   inischreiben('RegionalSettings','SystemLocale',Form3.SystemLocale.text);
   inischreiben('RegionalSettings','UserLocale',Form3.UserLocale.text);
   inischreiben('RegionalSettings','InputLocale',Form3.InputLocale.text);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  showmessage('PE-Creator is (c) 2005 by Dirk Paehl, this program run under the GPL.');
end;

procedure TForm1.Form1Create(Sender: TObject);
begin
  if paramcount <> 0 then unattend.text:=paramstr(1);
end;

initialization
  {$I unit1.lrs}

end.

